diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
index 82999466d..8ba5af230 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -2,18 +2,19 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicThermalVent
-        extends BlockLogic {
+public class BlockLogicThermalVent extends BlockLogic {
     public static final int META_MASK = 0b0000_0111;
     public static int DORMANT_STATE = 0;
     public static int VENTING_STATE = 4;
@@ -35,12 +36,12 @@ public class BlockLogicThermalVent
             return;
         }
 
-        world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 32, false);
+        world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 1000, true);
 
         if (state >= VENTING_STATE - 1) {
             for (int i = 0; i < 4; i++) {
-                world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 0, 32, false);
-                world.spawnParticle("smoke", xPos + rand.nextFloat() - 0.5D, yPos, zPos + rand.nextFloat() - 0.5D, 0.0D, 0.005D, 0.0D, 1, 32, false);
+                world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 0, 1000.0, true);
+                world.spawnParticle("smoke", xPos + rand.nextFloat() - 0.5D, yPos, zPos + rand.nextFloat() - 0.5D, 0.0D, 0.005D, 0.0D, 1, 1000.0, true);
             }
         }
     }
@@ -58,14 +59,28 @@ public class BlockLogicThermalVent
             return;
         }
 
-        int state = getVentState(world.getBlockData(tilePos));
-        if (state < VENTING_STATE) {
-            final int buildUpRate = getBuildupRate(world, tilePos, rand);
-            state += buildUpRate;
-            world.setBlockDataNotify(tilePos, state);
+        if (rand.nextInt(4) != 0) {
+            int state = getVentState(world.getBlockData(tilePos));
+            if (state < VENTING_STATE) {
+                final int buildUpRate = getBuildupRate(world, tilePos, rand);
+                state += buildUpRate;
+                world.setBlockDataNotify(tilePos, state);
+            } else {
+                vent(world, tilePos, rand);
+            }
+        }
+    }
+
+    private static void alertNearbyPlayers(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        double searchRadius = 200.0;
+        double ventX = tilePos.x() + 0.5D;
+        double ventY = tilePos.y() + 0.5D;
+        double ventZ = tilePos.z() + 0.5D;
+
+        List<Player> nearbyPlayers = world.getPlayersWithinRange(ventX, ventY, ventZ, searchRadius);
 
-        } else {
-            vent(world, tilePos, rand);
+        for (Player player : nearbyPlayers) {
+            player.handleThermalPing(player, ventX, ventY, ventZ, searchRadius);
         }
     }
 
@@ -73,8 +88,8 @@ public class BlockLogicThermalVent
         return META_MASK & data;
     }
 
-
     private static void vent(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
+
         for (int i = 0; i < 40; i++) {
             final double xPos = tilePos.x() + 0.5D;
             final double yPos = tilePos.y() + 1.125D;
@@ -83,17 +98,34 @@ public class BlockLogicThermalVent
             final double xd = (rand.nextFloat() - 0.5d) * 0.5d;
             final double zd = (rand.nextFloat() - 0.5d) * 0.5d;
 
-            world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.25D + rand.nextFloat(), 0.0D, 1, 32, false);
-            world.spawnParticle("flame", xPos, yPos, zPos, xd, 0.25D + rand.nextFloat(), zd, 0, 32, false);
+            world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.25D + rand.nextFloat(), 0.0D, 1, false);
+            world.spawnParticle("flame", xPos, yPos, zPos, xd, 0.25D + rand.nextFloat(), zd, 0, false);
         }
 
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x(), tilePos.y(), tilePos.z(), "random.explode", 2.0F, 0.5F + rand.nextFloat() * 0.2F);
 
-        final List<Entity> entities = world.getEntitiesWithinAABB(Entity.class, new AABBd(tilePos.x() - 1, tilePos.y(), tilePos.z() - 1, tilePos.x() + 1, tilePos.y() + 6, tilePos.z() + 1));
-        for (final @NotNull Entity entity : entities) {
-            entity.fling(0, 2, 0, 1f);
+        if (!world.isClientSide) {
+            alertNearbyPlayers(world, tilePos);
+
+            final List<Entity> entities = world.getEntitiesWithinAABB(Entity.class, new AABBd(tilePos.x() - 1, tilePos.y(), tilePos.z() - 1, tilePos.x() + 1, tilePos.y() + 6, tilePos.z() + 1));
+            for (final @NotNull Entity entity : entities) {
+                entity.fling(0, 2, 0, 1f);
+            }
+
+            world.setBlockDataNotify(tilePos, DORMANT_STATE);
+        }
+    }
+
+    @Override
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        super.onPlacedByWorld(world, tilePos);
+
+        if (!world.isClientSide) {
+            world.setBlockDataNotify(tilePos, world.rand.nextInt(VENTING_STATE));
         }
-        world.setBlockDataNotify(tilePos, DORMANT_STATE);
     }
 
-}
+    @Override
+    public @Nullable ParticleEmitterRange getParticleEmitterRange() {
+        return ParticleEmitterRange.FAR;
+    }
+}
\ No newline at end of file
